

-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "DS_IdleAnim"

-- **************************************************
-- General information about this script
-- **************************************************

DS_IdleAnim = {}

function DS_IdleAnim:Name()
	return "Idle animation"
end

function DS_IdleAnim:Version()
	return "0.1"
end

function DS_IdleAnim:Description()
	return "Idle animation"
end

function DS_IdleAnim:Creator()
	return "dauid.com"
end

function DS_IdleAnim:UILabel()
	return("Idle animation")
end

-- **************************************************
-- The guts of this script
-- **************************************************


function DS_IdleAnim:IsEnabled(moho)

	if (moho.layer:LayerType() ~= MOHO.LT_BONE) then --If a bone layer is not selected, disable the script
		return false
	end
skel = moho:Skeleton()
	if (skel == nil) then
			return false
	end

	return true
end

function DS_IdleAnim:randomNegative()
	num = math.random(2)
	if num == 2 then
	 num = -1
	 end
	 return num
end

function DS_IdleAnim:Run(moho)

local time1 = 1
local time2 = 50+ math.random(-15,15)
local time3 = 100+ math.random(-15,15)
local time4 = 150+ math.random(-15,15)
local time5 = 200+ math.random(-15,15)

local headvalue, fuparmvalue, buparmvalue,flowarmvalue,blowarmvalue, uptorsovalue, lowtorsovalues 
local startvalue
skel = moho:Skeleton()

for i = 0, skel:CountBones() - 1 do --For every bone do this
			theBone=skel:Bone(i)
			if theBone.fSelected then
			local ch = theBone.fAnimAngle
			startvalue = theBone.fAnimAngle:GetValue(1)
			theBone.fAnimAngle:SetValue(50+ math.random(-15,15), startvalue+(math.random(2,5)/250)*self:randomNegative())
			theBone.fAnimAngle:SetValue(100+ math.random(-15,15), startvalue+(math.random(2,5)/250)*self:randomNegative())
			theBone.fAnimAngle:SetValue(150+ math.random(-15,15), startvalue+(math.random(2,5)/250)*self:randomNegative())
			print(math.random(2,5)/500)
			theBone.fAnimAngle:SetValue(time5, startvalue)
			ch:SetKeyInterp(time5, 5, 0, 2)
			end
end
--[[
local cmd = f:read()
BoneTable={}
	while (cmd ~= nil) do --While there is still stuff in the loaded file
		if (string.sub(cmd, 1, 5) == "Bone:") then --If the current line in the file says "Bone:"
		loadedBoneName = f:read("*l") --Save the bone name read from the file
			for i = 0, skel:CountBones() - 1 do --For every bone do this
			theBone=skel:Bone(i)
			originalBoneName=theBone:Name()
				if (loadedBoneName==originalBoneName)then --If the loaded bone name has a namesake in the file


					-------------------------------------------------------------------Load bone angle (rotation)
					local numKeys
					loadedNum=f:read("*n")--First read how many keyframes there are
					local loadedFrames={}
					local loadedValues={}
					local valueDiff, newValue

					if (angleBox==true) and (relangleBox==true) then
							for numKeys=1, loadedNum do
							table.insert(loadedFrames, f:read("*n"))
							table.insert(loadedValues, f:read("*n"))
							valueDiff=loadedValues[numKeys]-loadedValues[1]
								if (flipBox==true) then
								newValue=theBone.fAnimAngle:GetValue(loadedFrames[1])-valueDiff
								else
								newValue=theBone.fAnimAngle:GetValue(loadedFrames[1])+valueDiff
								end
							theBone.fAnimAngle:SetValue(loadedFrames[numKeys], newValue)

							end

					elseif (angleBox==true) and (relangleBox==true) then
							for numKeys=1, loadedNum do
							table.insert(loadedFrames, f:read("*n"))
							table.insert(loadedValues, f:read("*n"))
							valueDiff=loadedValues[numKeys]-loadedValues[1]
							newValue=theBone.fAnimAngle:GetValue(loadedFrames[1])-valueDiff
							theBone.fAnimAngle:SetValue(loadedFrames[numKeys], newValue)

							end

					elseif (angleBox==true) and (relangleBox==false) then
							for numKeys=1, loadedNum do
								theBone.fAnimAngle:SetValue(f:read("*n"), f:read("*n"))

							end
					else

							for numKeys=1, loadedNum do
								local null=(f:read("*n")..f:read("*n"))

							end
					end

------------------------------------------------------------------------------------------Load bone position

					loadedNum=f:read("*n") --First read how many keyframes there are
					local vec=LM.Vector2:new_local()
					local vecb=LM.Vector2:new_local()
					local vecc=LM.Vector2:new_local()
					local loadedX={}
					local loadedY={}

					if (posBox==true) and (relaBox==true) then --Relabox is a checkbox for relative values
							loadedFrames={} --Clear the table so we can use it again

							for numKeys=1, loadedNum do
							table.insert(loadedFrames, f:read("*n")) 	--Insert all frame values in a table
							table.insert(loadedX, f:read("*n")) 		--Insert all X values in a table
							table.insert(loadedY, f:read("*n")) 		--Insert all Y values in a table
							vec.x=(loadedX[numKeys]-loadedX[1])			--Subtract every X value with the first X value so we only get the difference (the very first value will then be 0)
							vec.y=(loadedY[numKeys]-loadedY[1]) 		--Subtract every Y value with the first Y value so we only get the difference
							vecb=theBone.fAnimPos:GetValue(loadedFrames[1]) --Get the first position of the target bone (the position on the first loaded frame)
								if (flipBox==true) then
								vecc.x=vecb.x-vec.x -- Subtract difference from vecb to vecc (this will be the final position)
								else
								vecc.x=vecb.x+vec.x -- Add the difference from vecb to vecc (this will be the final position)
								end
							vecc.y=vecb.y+vec.y -- Do the same for Y
							theBone.fAnimPos:SetValue(loadedFrames[numKeys], vecc) --And set the position
							end



					elseif (posBox==true) and (relaBox==false) then
							for numKeys=1, loadedNum do
							frame=f:read("*n")
							vec.x=f:read("*n")
							vec.y=f:read("*n")
							theBone.fAnimPos:SetValue(frame, vec)
							end
					else
						for numKeys=1, loadedNum do
						local null=(f:read("*n")..f:read("*n")..f:read("*n"))
						end
					end

					-------------------------------------------------------------------Load locked frames for the bone
					local numKeys
					loadedNum=f:read("*n")--First read how many keyframes there are
					local lock, framenr

					if (lockBox==true) then
							for numKeys=1, loadedNum do
								framenr=f:read("*n")
								lock=f:read("*n")
								if (lock==0) then
								theBone.fIKLock:SetValue(framenr, false)
								else
								theBone.fIKLock:SetValue(framenr, true)
								end
							end
					else

							for numKeys=1, loadedNum do
								local null=(f:read("*n")..f:read("*n"))

							end
					end

					-------------------------------------------------------------------Load bone scale
					loadedNum=f:read("*n")--First read how many keyframes there are

					if (scaleBox==true) then
							for numKeys=1, loadedNum do
								theBone.fAnimScale:SetValue(f:read("*n"), f:read("*n"))

							end
					else

							for numKeys=1, loadedNum do
								local null=(f:read("*n")..f:read("*n"))

							end
					end





				end

			end

		end
		cmd = f:read()
	end

	f:close() --Close the file
]]--
end
