-- **************************************************
-- Provide Moho with the name of this script object
-- **************************************************

ScriptName = "DS_onetozero"

-- **************************************************
-- General information about this script
-- **************************************************

DS_onetozero = {}

function DS_onetozero:Name()
	return "Frame 1 to frame zero"
end

function DS_onetozero:Version()
	return "0.1"
end

function DS_onetozero:Description()
	return "Frame 1 to frame zero"
end

function DS_onetozero:Creator()
	return "dauid.com"
end

function DS_onetozero:UILabel()
	return"Frame 1 to frame zero"
end

-- **************************************************
-- The guts of this script
-- **************************************************

function DS_onetozero:clearKeys(moho, ch)
local lastFrame = ch:Duration()

--for i = 2, lastFrame do
	--if ch:HasKey(1) then
	--local v = ch:GetValue(1)
	--ch:SetValue(0,0)
	--ch:AddKey(50)
		--print("Deleted")
	--end
--end

--ch:CountKeys()
end

function DS_onetozero:getChannel(moho, layer)
	local numCh = layer:CountChannels()
	for i = 0, numCh - 2 do
		local chInfo = MOHO.MohoLayerChannel:new_local()
		moho.layer:GetChannelInfo(i, chInfo)
		if (chInfo.subChannelCount == 1) then
			local ch = moho.layer:Channel(i, 0, moho.document)
			self:clearKeys(moho, ch)
		else
			for subID = 0, chInfo.subChannelCount - 1 do
				local ch = moho.layer:Channel(i, subID, moho.document)
				self:clearKeys(moho, ch)
			end
		end
	end
end

function DS_onetozero:goThrough(moho, layer, nr)
	--
	
	--moho:SetSelLayer(layer)
	if ((layer:LayerType() == MOHO.LT_GROUP) or (layer:LayerType() == MOHO.LT_SWITCH) or (layer:LayerType() == MOHO.LT_BONE)) then		
		--self:getChannel(moho, layer)
		
		local layer = moho:LayerAsGroup(layer)
		layer:Expand(false)
		for i= 0, layer:CountLayers()-1 do
			self:goThrough(moho, layer:Layer(i), i)
		end
	elseif (layer:LayerType() == MOHO.LT_AUDIO) then		
	local layer = moho:LayerAsAudio(layer)
	layer:SetSpatialPositioning(false);
		--print(layer:Name())
	end
	
end

function DS_onetozero:Run(moho)    
		local numlayers = moho.document:CountLayers() --Do top layers
		for i = 0, numlayers - 1 do
			--moho:SetSelLayer(moho.document:Layer(i))
			local layer = moho.document:Layer(i)
			self:goThrough(moho, layer, i)
		end
end
